package cn.ibizlab.core.extensions.service;

import cn.ibizlab.core.lite.service.impl.MetaModelServiceImpl;
import lombok.extern.slf4j.Slf4j;
import cn.ibizlab.core.lite.domain.MetaModel;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.context.annotation.Primary;
import java.util.*;

/**
 * 实体[模型] 自定义服务对象
 */
@Slf4j
@Primary
@Service("MetaModelExService")
public class MetaModelExService extends MetaModelServiceImpl {

    @Override
    protected Class currentModelClass() {
        return com.baomidou.mybatisplus.core.toolkit.ReflectionKit.getSuperClassGenericType(this.getClass().getSuperclass(), 1);
    }

    /**
     * [Change:change] 行为扩展
     * @param et
     * @return
     */
    @Override
    @Transactional
    public MetaModel change(MetaModel et) {
        return super.change(et);
    }
    /**
     * [ExportFile:导出文件] 行为扩展：导出文件zip格式
     * @param et
     * @return
     */
    @Override
    @Transactional
    public MetaModel exportFile(MetaModel et) {
        return super.exportFile(et);
    }
    /**
     * [ImportFile:导入文件] 行为扩展：传入一个文件，将该文件转化成对象，根据对象执行表更新操作
     * @param et
     * @return
     */
    @Override
    @Transactional
    public MetaModel importFile(MetaModel et) {
        return super.importFile(et);
    }
}

